**      Foxpro print checks program
*       PCHKS
*  This program may be freely distributed
*  Written by Paul Plummer
*
*  DBF file structure used by this program
*
*  Field   Field name    Type           Width      Dec
*    1     REC           LOGICAL        1
*    2     P             LOGICAL        1
*    3     CHKN          NUMERIC        5
*    4     DATE          DATE           8
*    5     PAYEE         CHARACTER      40
*    6     AMOUNT        NUMERIC        8           2
*    7     CODE          CHARACTER      4
*
DIMENSION A0(20)
store 'zero' to a0(1)
store 'one' to a0(2)
store 'two' to a0(3)
store 'three' to a0(4)
store 'four' to a0(5)
store 'five' to a0(6)
store 'six' to a0(7)
store 'seven' to a0(8)
store 'eight' to a0(9)
store 'nine' to a0(10)
store 'ten' to a0(11)
store 'eleven' to a0(12)
store 'twelve' to a0(13)
store 'thirteen' to a0(14)
store 'fourteen' to a0(15)
store 'fifteen' to a0(16)
store 'sixteen' to a0(17)
store 'seventeen' to a0(18)
store 'eighteen' to a0(19)
store 'nineteen' to a0(20)
DIMENSION A1(10)
store '' to a1(1)
store '' to a1(2)
store 'twenty' to a1(3)
store 'thirty' to a1(4)
store 'forty' to a1(5)
store 'fifty' to a1(6)
store 'sixty' to a1(7)
store 'seventy' to a1(8)
store 'eighty' to a1(9)
store 'ninety' to a1(10)
clear
?'This function will print checks marked TRUE (T) in the P field.'
?'Be sure the check forms are loaded and positioned correctly'
?'before continuing.'
?' '
?'Also, be sure the check form numbers match the checks you'
?'are about to print.'
?
?'Once printed, all P fields are marked FALSE (F)'
?' '
wait 'Do you want to continue ? (Y/N)' to answer
if upper(answer) <> 'Y'
   return
endif
*    index chkn is indexed on field CHKN
use checks index chkn
set filter to P = .T.
go top
set talk off

?'Now printing checks marked P=T...'
?
?
set print on
do while .not. eof()
    tstrg = alltrim(payee)+'                                                  '
    tostrg = left(tstrg,57)
    pstrg = spellit(amount)+'-----------------------------------------------------------'
    ? ''
    ? ''
    ? ''
    ? '                                                                   '+dtoc(date)
    ? ''
    ? ''
    ? '        '+tostrg+str(amount,10,2)
    ? ''
    ?left(pstrg,70)
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    ? ''
    replace P with .F.
    skip

enddo
set print off
return
*******************************************************************************
FUNCTION SPELLIT
PARAMETERS NI
store '' to dstr
n = int(ni)
cents = int((ni - n)*100)
do case
    case n < 20
         dstr = lt20(n)
    case n < 100
         dstr = lt100(n)
    case n < 1000
         dstr = lt1000(n)
    case n < 1000000
         dstr = ltmill(n)
endcase
rstrg = alltrim(dstr)+" and "+alltrim(str(cents))+" cents"
uchar = upper(left(rstrg,1))
RETURN uchar+right(rstrg,len(rstrg)-1)
******************************************************************************
FUNCTION LT20
PARAMETERS N
return a0(n+1)
******************************************************************************
FUNCTION LT100
PARAMETERS N
d1 = int(n/10)
s1 = a1(d1+1)
d2 = n - d1*10
if d2 = 0
   s2 = ''
   return s1
else
   s2 = a0(d2+1)
   return s1+' '+s2
endif
******************************************************************************
FUNCTION LT1000
PARAMETERS N
dd1 = int(n/100)
ss1 = lt20(dd1)
d2d3 = n - dd1*100
if d2d3 = 0
   s2s3 = ''
   return ss1+' hundred'
else
   do case
      case d2d3 < 20
         s2s3 = lt20(d2d3)
      case d2d3 < 100
         s2s3 = lt100(d2d3)
   endcase
   return ss1+' hundred '+alltrim(s2s3)
endif
******************************************************************************
FUNCTION LTMILL
PARAMETERS N
strgn = alltrim(str(n))
store len(strgn) to strglen
lstrg = left(strgn,strglen-3)
ln = val(lstrg)
do case
    case ln < 20
        ustr = lt20(ln)
    case ln < 100
        ustr = lt100(ln)
    case ln < 1000
        ustr = lt1000(ln)
endcase
rn = val(right(strgn,3))

if rn = 0
    lstrg = ''
else
    do case
    case rn < 20
        lstrg = lt20(rn)
    case rn < 100
        lstrg = lt100(rn)
    case rn < 1000
    lstrg = lt1000(rn)
endcase
endif
return alltrim(ustr)+' thousand '+alltrim(lstrg)
